﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file DemoGameScreen.cpp
 *
 * Реализация DemoGameScreen.hpp.
 */
#include "DemoGameScreen.hpp"
#include <avo/Timer.hpp>

using namespace std;
using namespace avo;


void DemoGameScreen::onIdle()
{
  static const char actions[32] = "awds";

  sleep(0.02);
  // случайная игра-демонстрация, пока что выполнена в виде случайного блуждания для простоты
  Base::onIdle ();
  if (rand() & 1)
    Base::onMouse(GLUT_RIGHT_BUTTON, rand(), rand());
  else
    Base::onChar(actions[rand() % 32], 0, 0);

  if (isPaused())
    Base::onChar(' ', 0, 0);

  // TASK: попробовать реализовать более умное поведение змейки в демонстрации игры.
}


void DemoGameScreen::onDisplay()
{
  Base::onDisplay ();
  glEnable(GL_BLEND); // включить интерпретацию альфа канала как коэффициента смешивания цветов для имитации прозрачности
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // выбрать формулу смешивания
}


// нарисовать полупрозрачный прямоугольник в ширину игрового экрана с заданным покрытием по вертикали
void DemoGameScreen::greyRect(float bottom, float top)
{
  Color(0.0f, 0.6f).select();
  glRectf(0.005f, bottom - 0.01f, 0.995f, top - 0.005f);
}


//
// вспомогательные функции для получения случайных цветов

/// возвращает псевдослучайное значение в диапазоне [0, 1]
inline float random01()
{
  return float(rand()) / float(RAND_MAX);
}

// возвращает псевдослучайный цвет
Color DemoGameScreen::random_color()
{
  return Color(random01(), random01(), random01());
}
