﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file ViewModelBase.hpp
 *
 * Базовые определения, используемые и моделью и видом.
 */
#pragma once
#include <cstdint>

/// клетка поля
using Cell = std::uint8_t;
/// базовые варианты клеток
const Cell Cell_Empty  = 0,
           Cell_Snake  = 1,
           Cell_Rabbit = 2, // +1, +2... -- виды "кроликов"
           Cell_Types  = 5; // но < Cell_Types

/// тип индекса поля
using Index = unsigned;

/// тип для хранения заработанных очков
using Score = std::uint_fast32_t;
